//
//  ConceptDictionaries.m
//  SubjectiveKit
//
//  Created by Kota Mizushima on 2012/10/26.
//
//

#import "ConceptDictionaries.h"
#import "Monoids.h"

@implementation ConceptDictionaries

+ (ConceptDictionaries*)sharedInstance {
    static ConceptDictionaries* instance;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [ConceptDictionaries new];
        instance.concepts[[[[Monoids intMonoid] class] description]] = [Monoids intMonoid];
        instance.concepts[[[[Monoids doubleMonoid] class] description]] = [Monoids doubleMonoid];
        instance.concepts[[[[Monoids stringMonoid] class] description]] = [Monoids stringMonoid];
    });
    return instance;
}

- (id)init {
    self = [super init];
    _concepts = [NSMutableDictionary dictionary];
    
    return self;
}


@end
