//
// Created by mizushima on 2012/09/06.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import "Monoids.h"
#import "Monoid.h"


@implementation Monoids 
    
+ (NSObject<Monoid>*)intMonoid {
    return [IntMonoid sharedInstance];
}

+ (NSObject<Monoid>*)stringMonoid {
    return [StringMonoid sharedInstance];
}

+ (NSObject<Monoid>*)doubleMonoid {
    return [DoubleMonoid sharedInstance];
}

@end

@implementation IntMonoid

+ (IntMonoid*)sharedInstance {
    static IntMonoid* instance;
    
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [IntMonoid new];
    });
    
    return instance;
}

- (NSObject*)zero {
    return [NSNumber numberWithInt:0];
}

- (NSObject*)plus:(NSObject *)a by:(NSObject *)b {
    return [NSNumber numberWithInteger:((NSNumber*)a).integerValue + ((NSNumber*)b).integerValue];
}

@end

@implementation StringMonoid

+ (StringMonoid *)sharedInstance {
    static StringMonoid* instance;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [StringMonoid new];
    });
    return instance;
}

- (NSObject *)plus:(NSObject *)a by:(NSObject *)b {
    return [((NSString *) a) stringByAppendingString:(NSString *)b];
}

- (NSObject *)zero {
    return @"";
}

@end

@implementation DoubleMonoid

+ (DoubleMonoid *)sharedInstance {
    static DoubleMonoid* instance;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [DoubleMonoid new];
    });
    return instance;
}

- (NSObject *)plus:(NSObject *)a by:(NSObject *)b {
    return [NSNumber numberWithDouble:((NSNumber *)a).doubleValue + ((NSNumber*)b).doubleValue];
}

- (NSObject *)zero {
    return [NSNumber numberWithDouble:0.0];
}

@end