//
//  NSDictionary+HigherOrderFunctionsTestCase.m
//  SubjectiveKit
//
//  Created by Kota Mizushima on 2012/10/26.
//
//

#import "NSDictionary+HigherOrderFunctionsTestCase.h"
#import "NSDictionary+HigherOrderFunctions.h"

@implementation NSDictionary_HigherOrderFunctionsTestCase

- (void)testEach {
    NSDictionary* src = @{@"k1":@"v1", @"k2":@"v2"};
    NSMutableSet* keySet = [NSMutableSet set];
    NSMutableSet* valueSet = [NSMutableSet set];
    [src each:^id(NSString* key, NSString* value) {
        [keySet addObject:key];
        [valueSet addObject:value];
        return nil;
    }];
    
    NSSet* keySetExpected = [NSSet setWithArray:@[@"k1", @"k2"]];
    NSSet* valueSetExpected = [NSSet setWithArray:@[@"v1", @"v2"]];
    
    STAssertEqualObjects(keySet, keySetExpected, nil);
    STAssertEqualObjects(valueSet, valueSetExpected, nil);
}

@end
